<?php
 class CStudentInClassAccess extends CTblAccess {
	//饹˻äƤּԤ򰷤饹
	var $moodle_student_arr;

	function CStudentInClassAccess () {
		$this->CTblAccess (STU_TBL." AS st, ".USR_TBL." AS ut");
	}

	function getStudentsInClass($conn, $class_id) {
		//ۤ
		$want_col = "ut.id, ut.username, ut.password, ut.firstname,ut.lastname, ut.email,ut.lang, ut.timemodified";
		$condition = " WHERE ut.id = st.userid AND ut.deleted = 0 AND ";

		$condition .= "st.course = '".$this->escapeSqlString($class_id)."'";
		$result = $this->getList($want_col, $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}

	function setStudentsOfClass($conn, $class_id) {
		//ۤ
		$want_col = "ut.id AS mid, ut.username, ut.password, ut.firstname,ut.lastname, ut.email,ut.lang, ut.timemodified";
		$condition = " WHERE ut.id = st.userid AND ut.deleted = 0 AND ";

		$condition .= "st.course = '".$this->escapeSqlString($class_id)."'";
		if (!$this->setListWithKey("mid",$want_col, $condition, $conn)) {
			return false;
		}
		$this->moodle_student_arr = $this->getSelectedList ();
		return true;
	}
	
	function getStudentsOfClass () {
		return $this->moodle_student_arr;
	}
}

class CClassPerStudents extends CTblAccess {
	var $course_list;
	function CClassPerStudents () {
		$this->CTblAccess(USR_TBL." AS ut, ".STU_TBL." AS st, ".COURSE_TBL." AS ct");
	}
	
	function setCourseList ($conn, $mid) {
		$want_col = "ut.id AS mid, ut.email, ut.username, ut.firstname, ut.lastname, ct.fullname, ct.summary";
		$condition = " WHERE ut.id = st.userid AND st.course = ct.id AND ut.id='".$this->escapeSqlString($mid)."'";
		if (!$this->setSelectedList($want_col, $condition, $conn)) {
			return false;
		}
		$this->course_list = $this->getSelectedList();
		return true;
	}
	
	function getCourseList () {
		return $this->course_list;
	}
}

class CClassPerTeachers extends CTblAccess {
	var $course_list;
	function CClassPerTeachers () {
		$this->CTblAccess(USR_TBL." AS ut, ".TEA_TBL." AS tt, ".COURSE_TBL." AS ct");
	}
	
	function setCourseList ($conn, $mid) {
		$want_col = "ut.id AS mid, ut.email, ut.username, ut.firstname, ut.lastname, ct.fullname, ct.summary";
		$condition = " WHERE ut.id = tt.userid AND tt.course = ct.id AND ut.id='".$this->escapeSqlString($mid)."'";
		if (!$this->setSelectedList($want_col, $condition, $conn)) {
			return false;
		}
		$this->course_list = $this->getSelectedList();
		return true;
	}
	
	function getCourseList () {
		return $this->course_list;
	}
}


 class CTeacherInClassAccess extends CTblAccess {
	//饹˻äƤ붵򰷤饹
	//MoodleΥ⥸塼Ǥѹ
	var $moodle_teacher_arr;
	function CTeacherInClassAccess () {
		$this->CTblAccess (TEA_TBL." AS tt, ".USR_TBL." AS ut");
	}

	function getTeachersInClass($conn, $class_id) {
		//ۤ
		$want_col = "ut.id, ut.username, ut.firstname,ut.lastname, ut.email,ut.lang, ut.timemodified";
		$condition = " WHERE ut.id = tt.userid AND ut.deleted = 0 AND ";
		$condition .= "tt.course = '".$this->escapeSqlString($class_id)."'";
		$result = $this->getList($want_col, $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}
	
	function setTeachersOfClass ($conn, $class_id) {
		$want_col = "ut.id AS mid, ut.username, ut.password, ut.firstname,ut.lastname, ut.email,ut.lang, ut.timemodified";
		$condition = " WHERE ut.id = tt.userid AND ut.deleted = 0 AND ";
		$condition .= "tt.course = '".$this->escapeSqlString($class_id)."'";
		if (!$this->setListWithKey("mid",$want_col, $condition, $conn)) {
			return false;
		}
		$this->moodle_teacher_arr = $this->getSelectedList ();
		return true;
	}
	
	function getTeachersOfClass () {
		return $this->moodle_teacher_arr;
	}

}

class CMClassListAccess extends CTblAccess {
	//admin/index.phpʤɤѤСθƤӽФ
	function CMClassListAccess () {
		$this->CTblAccess ("NOT SET");
	}
	
	function setNumbersPerGroup ($conn) {
		//롼פ򥭡ȤͿμ
		$this->tbl_name = COURSE_TBL." AS mc ";
		$condition = "LEFT JOIN ".STU_TBL." AS mus ON mus.course = mc.id ";
		$condition .= "LEFT JOIN ".TEA_TBL." AS mut ON mut.course = mc.id ";
		$condition .= "GROUP BY mc.id";
		$want_col = "mc.id, COUNT (DISTINCT mus.id) AS stu_num, COUNT (DISTINCT mut.id) AS tea_num";
		if (!$this->setListWithKey("id", $want_col, $condition, $conn)) return false;
		return true;
	}
}
?>